﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Diagnostics;
using System.Windows.Forms;
using PluginBase;

namespace SamplePlugin
{
    class SampleROMDataSet : ROMDataSet
    {
        public SampleROMDataSet()
        {
        }


        /// <summary>
        /// プレインなROMDataSetを元にSampleROMDataSetを初期化
        /// おそらく変更不要
        /// </summary>
        /// <param name="ds"></param>
        public SampleROMDataSet(ROMDataSet ds)
        {
            DataTable[] tarray = new DataTable[ds.Tables.Count];
            ds.Tables.CopyTo(tarray, 0);
            ds.Tables.Clear();
            this.Tables.Clear();
            this.Tables.AddRange(tarray);

            this.ROMIndexTable = ds.ROMIndexTable;
            this.SRIndexTable = ds.SRIndexTable;
            this.TDIndexTable = ds.TDIndexTable;
            this.ar = ds.ar;
        }

        /// <summary>
        /// ROMイメージを再読み込みする
        /// </summary>
        public override bool ReloadROMImage(ref int NodeCount)
        {
            if (ar.Count == 0) return false;

            //時間計測用変数
            long t4, t5, t6, t7;
            Stopwatch s1 = new Stopwatch();
            TimeBD = "";
            s1.Start();
            try
            {
/*
                //DQ3,6では文字列のデコードを特殊処理として追加で行っている
                this.SetStringInfo();
                this.SetBattleMsgInfo();
                this.SetMsgInfo();
 */
            }
            catch (Exception e)
            {
                string str = e.Message;
            }
            s1.Stop();
            t4 = s1.ElapsedMilliseconds / 1000;
            s1.Reset();
            s1.Start();


            //以下の処理は省略できない 変更せずにそのまま使うこと
            //ExtractTablesは廃止
            //this.ExtractTables();

            s1.Stop();
            t5 = s1.ElapsedMilliseconds / 1000;
            s1.Reset();
            s1.Start();


            //自動逆アセンブルの実行
            int count = 0;
            if (!PluginHost.Lite)
            {
                count = this.DisassembleSRs();
            }

            s1.Stop();
            t6 = s1.ElapsedMilliseconds / 1000;
            s1.Reset();
            s1.Start();
            //空き領域情報の作成
            this.MakeEmptyArea();
            s1.Stop();
            t7 = s1.ElapsedMilliseconds / 1000;
            TimeBD += "--String Parsing:" + t4.ToString() + "sec\r\n";
            //TimeBD2は廃止ｂ
            //TimeBD += TimeBD2;
            TimeBD += "--DataPart Building:" + t5.ToString() + "sec\r\n";
            TimeBD += "--CodePart Building:" + t6.ToString() + "sec " + count.ToString() + "\r\n";
            TimeBD += "--EmptyArea Making:" + t7.ToString() + "sec\r\n";
            
            //GCの実行
            GC.Collect();

            return true;
        }
    }
}
